## tensorpipe 0.0~git20200805.42033c5

=== CMakeLists.txt ===
# Copyright (c) Facebook, Inc. and its affiliates.
# All rights reserved.
#
# This source code is licensed under the BSD-style license found in the
# LICENSE file in the root directory of this source tree.

cmake_minimum_required(VERSION 3.5 FATAL_ERROR)

project(tensorpipe LANGUAGES C CXX)

set(CMAKE_CXX_STANDARD 14)

list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")

# Enable protobuf_generate() polyfill.
include(cmake/ProtobufGenerate.cmake)

# Expose build options.
include(Options)

# Define sanitizer option, if specified.
include(Sanitize)

# We use the [[nodiscard]] attribute, which GCC 5 complains about.
# Silence this warning if GCC 5 is used.
if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
  if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 6)
    add_definitions("-Wno-attributes")
  endif()
endif()

add_subdirectory(tensorpipe)

install(EXPORT TensorpipeTargets
        DESTINATION share/cmake/Tensorpipe
        FILE TensorpipeTargets.cmake)

=== tensorpipe/CMakeLists.txt ===
# Copyright (c) Facebook, Inc. and its affiliates.
# All rights reserved.
#
# This source code is licensed under the BSD-style license found in the
# LICENSE file in the root directory of this source tree.

add_library(tensorpipe
  ${TP_STATIC_OR_SHARED}
  channel/error.cc
  channel/helpers.cc
  channel/registry.cc
  common/address.cc
  common/error.cc
  common/system.cc
  core/context.cc
  core/error.cc
  core/listener.cc
  core/pipe.cc
  proto/core.proto
  transport/connection.cc
  transport/error.cc
  transport/registry.cc)

# Support `#include <tensorpipe/foo.h>`.
target_include_directories(tensorpipe PUBLIC $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}>)

# Support `#include <tensorpipe/tensorpipe.h>` and `#include <tensorpipe/proto/foo.pb.h>`.
target_include_directories(tensorpipe PUBLIC $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}>)

# Support `#include "proto/foo.pb.h"`, as generated by protoc.
target_include_directories(tensorpipe PRIVATE ${PROJECT_BINARY_DIR}/tensorpipe)


## Channels

### basic

target_sources(tensorpipe PRIVATE
  channel/basic/channel.cc
  channel/basic/context.cc)

### xth

target_sources(tensorpipe PRIVATE
  channel/xth/channel.cc
  channel/xth/context.cc
  proto/channel/xth.proto)

### cma

if(TP_ENABLE_CMA)
  target_sources(tensorpipe PRIVATE
    channel/cma/channel.cc
    channel/cma/context.cc
    proto/channel/cma.proto)
  set(TENSORPIPE_HAS_CMA_CHANNEL 1)
else()
  set(TENSORPIPE_HAS_CMA_CHANNEL 0)
endif()

### mpt

target_sources(tensorpipe PRIVATE
  channel/mpt/channel.cc
  channel/mpt/context.cc
  proto/channel/mpt.proto)


## Transports

### uv

target_sources(tensorpipe PRIVATE
  transport/uv/connection.cc
  transport/uv/context.cc
  transport/uv/error.cc
  transport/uv/listener.cc
  transport/uv/loop.cc
  transport/uv/sockaddr.cc
  transport/uv/uv.cc)
find_package(uv REQUIRED)
target_link_libraries(tensorpipe PRIVATE uv::uv)

### shm

if(TP_ENABLE_SHM)
  target_sources(tensorpipe PRIVATE
    transport/shm/context.cc
    transport/shm/connection.cc
    transport/shm/fd.cc
    transport/shm/listener.cc
    transport/shm/loop.cc
    transport/shm/reactor.cc
    transport/shm/socket.cc
    util/ringbuffer/shm.cc
    util/shm/segment.cc)
  set(TENSORPIPE_HAS_SHM_TRANSPORT 1)
else()
  set(TENSORPIPE_HAS_SHM_TRANSPORT 0)
endif()


if(APPLE)
  find_library(CF CoreFoundation)
  find_library(IOKIT IOKit)
  target_link_libraries(tensorpipe PRIVATE ${CF} ${IOKIT})
endif()


## Protobufs

if(NOT TARGET protobuf::libprotobuf)
  if(Protobuf_DIR)
    find_package(Protobuf 3 REQUIRED HINTS "${Protobuf_DIR}")
  else()
    find_package(Protobuf 3 REQUIRED)
  endif()
endif()

target_link_libraries(tensorpipe PRIVATE protobuf::libprotobuf)
protobuf_generate(TARGET tensorpipe)


if(BUILD_SHARED_LIBS)
  set_target_properties(tensorpipe PROPERTIES POSITION_INDEPENDENT_CODE 1)
endif()


## Config

configure_file(tensorpipe.h.in tensorpipe.h)


## Python bindings

if(TP_BUILD_PYTHON)
  add_subdirectory(python)
endif()


## Benchmarks

if (TP_BUILD_BENCHMARK)
  add_subdirectory(benchmark)
endif()


## Tests

if(TP_BUILD_TESTING)
  add_subdirectory(test)
endif()


## Install

install(TARGETS tensorpipe
        EXPORT TensorpipeTargets
        LIBRARY DESTINATION ${TP_INSTALL_LIBDIR}
        ARCHIVE DESTINATION ${TP_INSTALL_LIBDIR})

=== tensorpipe/benchmark/CMakeLists.txt ===
# Copyright (c) Facebook, Inc. and its affiliates.
# All rights reserved.
#
# This source code is licensed under the BSD-style license found in the
# LICENSE file in the root directory of this source tree.

# TODO: Make those separate CMake projects.

add_executable(benchmark_transport benchmark_transport.cc options.cc)
target_link_libraries(benchmark_transport PRIVATE tensorpipe)

add_executable(benchmark_pipe benchmark_pipe.cc options.cc)
target_link_libraries(benchmark_pipe PRIVATE tensorpipe)

=== tensorpipe/test/CMakeLists.txt ===
# Copyright (c) Facebook, Inc. and its affiliates.
# All rights reserved.
#
# This source code is licensed under the BSD-style license found in the
# LICENSE file in the root directory of this source tree.

add_executable(tensorpipe_test
  test.cc
  transport/context_test.cc
  transport/connection_test.cc
  transport/uv/uv_test.cc
  transport/uv/context_test.cc
  transport/uv/loop_test.cc
  transport/uv/connection_test.cc
  transport/uv/sockaddr_test.cc
  transport/listener_test.cc
  core/context_test.cc
  proto/core_test.cc
  channel/basic/basic_test.cc
  channel/xth/xth_test.cc
  channel/mpt/mpt_test.cc
  channel/channel_test.cc
  common/system_test.cc
  common/defs_test.cc
  )

if(TP_ENABLE_SHM)
  target_sources(tensorpipe_test PRIVATE
    transport/shm/reactor_test.cc
    transport/shm/loop_test.cc
    transport/shm/connection_test.cc
    transport/shm/sockaddr_test.cc
    transport/shm/shm_test.cc
    util/ringbuffer/shm_ringbuffer_test.cc
    util/ringbuffer/protobuf_streams_test.cc
    util/ringbuffer/ringbuffer_test.cc
    util/shm/segment_test.cc
    )
endif()

if(TP_ENABLE_CMA)
  target_sources(tensorpipe_test PRIVATE
    channel/cma/cma_test.cc
    )
endif()

add_subdirectory(${PROJECT_SOURCE_DIR}/third_party/googletest
  ${PROJECT_BINARY_DIR}/third_party/googletest)

# Support `#include <tensorpipe/proto/foo.pb.h>`
target_include_directories(tensorpipe_test PRIVATE ${PROJECT_BINARY_DIR})

target_link_libraries(tensorpipe_test PRIVATE
  tensorpipe
  uv::uv
  protobuf::libprotobuf-lite
  gtest_main)

=== debian/changelog ===
tensorpipe (0.0~git20200805.42033c5-3) unstable; urgency=medium

  * Fixup FTBFS due to incomplete not-installed file list.

 -- Mo Zhou <lumin@debian.org>  Mon, 19 Oct 2020 15:41:04 +0800

tensorpipe (0.0~git20200805.42033c5-2) unstable; urgency=medium

  * Change maintainer mail address into debian-ai@l.d.o
  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Mon, 19 Oct 2020 13:09:41 +0800

tensorpipe (0.0~git20200805.42033c5-1) experimental; urgency=medium

  * Initial release. (Closes: #968426)

 -- Mo Zhou <lumin@debian.org>  Sun, 30 Aug 2020 19:39:49 +0800

=== debian/control ===
Source: tensorpipe
Section: science
Homepage: https://github.com/pytorch/tensorpipe
Priority: optional
Standards-Version: 4.5.0
Vcs-Git: https://salsa.debian.org/deeplearning-team/tensorpipe.git
Vcs-Browser: https://salsa.debian.org/deeplearning-team/tensorpipe
Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
Uploaders: Mo Zhou <lumin@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               libgtest-dev,
               libprotobuf-dev,
               libuv1-dev,
               pkg-config,
               protobuf-compiler,
Rules-Requires-Root: no

Package: libtensorpipe-dev
Section: libdevel
Architecture: any
Depends: libtensorpipe0 (= ${binary:Version}), ${misc:Depends}
Description: tensor-aware point-to-point communication primitive for machine learning
 The TensorPipe project provides a tensor-aware channel to transfer rich
 objects from one process to another while using the fastest transport for the
 tensors contained therein (e.g., CUDA device-to-device copy).
 .
 This package contains development files.

Package: libtensorpipe0
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: tensor-aware point-to-point communication primitive for machine learning
 The TensorPipe project provides a tensor-aware channel to transfer rich
 objects from one process to another while using the fastest transport for the
 tensors contained therein (e.g., CUDA device-to-device copy).
 .
 This package contains shared objects.

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ -Scmake

override_dh_auto_configure:
	-$(RM) -rfv third_party/googletest third_party/libuv
	ln -sfv /usr/src/googletest third_party/
	dh_auto_configure -- -DBUILD_SHARED_LIBS=ON -DTP_BUILD_TESTING=ON

## tensorpipe 0.0~git20200928.95ff931

=== CMakeLists.txt ===
# Copyright (c) Facebook, Inc. and its affiliates.
# All rights reserved.
#
# This source code is licensed under the BSD-style license found in the
# LICENSE file in the root directory of this source tree.

add_library(tensorpipe
  ${TP_STATIC_OR_SHARED}
  channel/error.cc
  channel/helpers.cc
  channel/registry.cc
  common/address.cc
  common/error.cc
  common/fd.cc
  common/socket.cc
  common/system.cc
  core/context.cc
  core/error.cc
  core/listener.cc
  core/pipe.cc
  transport/connection.cc
  transport/error.cc
  transport/registry.cc)

# Support `#include <tensorpipe/foo.h>`.
target_include_directories(tensorpipe PUBLIC $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}>)

# Support `#include <tensorpipe/tensorpipe.h>`.
target_include_directories(tensorpipe PUBLIC $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}>)


## Channels

### basic

target_sources(tensorpipe PRIVATE
  channel/basic/channel.cc
  channel/basic/context.cc)

### xth

target_sources(tensorpipe PRIVATE
  channel/xth/channel.cc
  channel/xth/context.cc)

### cma

if(TP_ENABLE_CMA)
  target_sources(tensorpipe PRIVATE
    channel/cma/channel.cc
    channel/cma/context.cc)
  set(TENSORPIPE_HAS_CMA_CHANNEL 1)
else()
  set(TENSORPIPE_HAS_CMA_CHANNEL 0)
endif()

### mpt

target_sources(tensorpipe PRIVATE
  channel/mpt/channel.cc
  channel/mpt/context.cc)

## CUDA channels

if(TP_USE_CUDA)
  find_package(CUDA REQUIRED)
  target_link_libraries(tensorpipe PUBLIC ${CUDA_LIBRARIES})
  target_include_directories(tensorpipe PUBLIC ${CUDA_INCLUDE_DIRS})
  set(TENSORPIPE_SUPPORTS_CUDA 1)

  ### cuda_ipc

  if(TP_ENABLE_CUDA_IPC)
    target_sources(tensorpipe PRIVATE
      channel/cuda_ipc/channel.cc
      channel/cuda_ipc/context.cc)
    set(TENSORPIPE_HAS_CUDA_IPC_CHANNEL 1)
  endif()
endif()

## Transports

### uv

target_sources(tensorpipe PRIVATE
  transport/uv/connection.cc
  transport/uv/context.cc
  transport/uv/error.cc
  transport/uv/listener.cc
  transport/uv/loop.cc
  transport/uv/sockaddr.cc
  transport/uv/uv.cc)
find_package(uv REQUIRED)
target_link_libraries(tensorpipe PRIVATE uv::uv)

### shm

if(TP_ENABLE_SHM)
  target_sources(tensorpipe PRIVATE
    transport/shm/context.cc
    transport/shm/connection.cc
    transport/shm/listener.cc
    transport/shm/loop.cc
    transport/shm/reactor.cc
    transport/shm/sockaddr.cc
    util/ringbuffer/shm.cc
    util/shm/segment.cc)
  set(TENSORPIPE_HAS_SHM_TRANSPORT 1)
else()
  set(TENSORPIPE_HAS_SHM_TRANSPORT 0)
endif()


if(APPLE)
  find_library(CF CoreFoundation)
  find_library(IOKIT IOKit)
  target_link_libraries(tensorpipe PRIVATE ${CF} ${IOKIT})
endif()


if(BUILD_SHARED_LIBS)
  set_target_properties(tensorpipe PROPERTIES POSITION_INDEPENDENT_CODE 1)
endif()


## Config

configure_file(config.h.in config.h)


## Libnop

# We should keep libnop headers private as they should not be exposed to downstream users,
# but they're currently transitively included by tensorpipe/transport/connection.h (which
# is still unclear whether it should be a public or private header).
target_include_directories(tensorpipe PUBLIC $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/third_party/libnop/include>)


## Python bindings

if(TP_BUILD_PYTHON)
  add_subdirectory(python)
endif()


## Benchmarks

if (TP_BUILD_BENCHMARK)
  add_subdirectory(benchmark)
endif()


## Tests

if(TP_BUILD_TESTING)
  add_subdirectory(test)
endif()


## Install

install(TARGETS tensorpipe
        EXPORT TensorpipeTargets
        LIBRARY DESTINATION ${TP_INSTALL_LIBDIR}
        ARCHIVE DESTINATION ${TP_INSTALL_LIBDIR})

=== benchmark/CMakeLists.txt ===
# Copyright (c) Facebook, Inc. and its affiliates.
# All rights reserved.
#
# This source code is licensed under the BSD-style license found in the
# LICENSE file in the root directory of this source tree.

# TODO: Make those separate CMake projects.

add_executable(benchmark_transport benchmark_transport.cc options.cc)
target_link_libraries(benchmark_transport PRIVATE -Wl,--whole-archive tensorpipe -Wl,--no-whole-archive)

add_executable(benchmark_pipe benchmark_pipe.cc options.cc)
target_link_libraries(benchmark_pipe PRIVATE -Wl,--whole-archive tensorpipe -Wl,--no-whole-archive)

=== test/CMakeLists.txt ===
# Copyright (c) Facebook, Inc. and its affiliates.
# All rights reserved.
#
# This source code is licensed under the BSD-style license found in the
# LICENSE file in the root directory of this source tree.

add_executable(tensorpipe_test
  test.cc
  transport/context_test.cc
  transport/connection_test.cc
  transport/uv/uv_test.cc
  transport/uv/context_test.cc
  transport/uv/loop_test.cc
  transport/uv/connection_test.cc
  transport/uv/sockaddr_test.cc
  transport/listener_test.cc
  core/context_test.cc
  channel/basic/basic_test.cc
  channel/xth/xth_test.cc
  channel/mpt/mpt_test.cc
  channel/channel_test.cc
  channel/channel_test_cpu.cc
  common/system_test.cc
  common/defs_test.cc
  )

if(TP_ENABLE_SHM)
  target_sources(tensorpipe_test PRIVATE
    transport/shm/reactor_test.cc
    transport/shm/loop_test.cc
    transport/shm/connection_test.cc
    transport/shm/sockaddr_test.cc
    transport/shm/shm_test.cc
    util/ringbuffer/shm_ringbuffer_test.cc
    util/ringbuffer/ringbuffer_test.cc
    util/shm/segment_test.cc
    )
endif()

if(TP_ENABLE_CMA)
  target_sources(tensorpipe_test PRIVATE
    channel/cma/cma_test.cc
    )
endif()

if(TP_USE_CUDA)
  find_package(CUDA REQUIRED)
  target_link_libraries(tensorpipe_test PRIVATE ${CUDA_LIBRARIES})
  target_include_directories(tensorpipe_test PRIVATE ${CUDA_INCLUDE_DIRS})

  target_sources(tensorpipe_test PRIVATE
    channel/channel_test_cuda.cc
    )

  cuda_add_library(tensorpipe_cuda_kernel channel/kernel.cu)
  target_link_libraries(tensorpipe_test PRIVATE tensorpipe_cuda_kernel)
endif()

if(TP_ENABLE_CUDA_IPC)
  target_sources(tensorpipe_test PRIVATE
    channel/cuda_ipc/cuda_ipc_test.cc
    )
endif()


add_subdirectory(${PROJECT_SOURCE_DIR}/third_party/googletest
  ${PROJECT_BINARY_DIR}/third_party/googletest)

target_link_libraries(tensorpipe_test PRIVATE
  tensorpipe
  uv::uv
  gtest_main)

=== debian/changelog ===
tensorpipe (0.0~git20200928.95ff931-2) unstable; urgency=medium

  * Amend the list of headers -- one header was still missing.
  * Make libtensorpipe-dev depend on libnop-dev.

 -- Mo Zhou <lumin@debian.org>  Sat, 07 Nov 2020 17:05:50 +0800

tensorpipe (0.0~git20200928.95ff931-1) unstable; urgency=medium

  [ Adrian Bunk ]
  * Workaround FTBFS on armel/mipsel/m68k/powerpc/riscv64/sh4 (Closes: #972966)

  [ Mo Zhou ]
  * New upstream version 0.0~git20200928.95ff931 (PyTorch 1.7.0)
  * Remove two obsolete patches and refresh the remaining ones.
  * Add NEW B-D libnop-dev.
  * Refresh the list of headers to be installed.
  * Please pin to this upstream snapshot for PyTorch 1.7.0

 -- Mo Zhou <lumin@debian.org>  Mon, 02 Nov 2020 12:34:08 +0800

=== debian/rules ===
--- 
+++ 
@@ -1,5 +1,9 @@
 #!/usr/bin/make -f
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+
+ifneq (,$(filter $(DEB_HOST_ARCH), armel m68k mipsel powerpc riscv64 sh4))
+  export DEB_LDFLAGS_MAINT_APPEND += -Wl,--no-as-needed -latomic -Wl,--as-needed
+endif
 
 %:
 	dh $@ -Scmake

## tensorpipe 0.0~git20210304.369e855

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,19 +8,19 @@
   ${TP_STATIC_OR_SHARED}
   channel/error.cc
   channel/helpers.cc
-  channel/registry.cc
   common/address.cc
   common/error.cc
   common/fd.cc
   common/socket.cc
   common/system.cc
   core/context.cc
+  core/context_impl.cc
   core/error.cc
   core/listener.cc
+  core/listener_impl.cc
   core/pipe.cc
-  transport/connection.cc
-  transport/error.cc
-  transport/registry.cc)
+  core/pipe_impl.cc
+  transport/error.cc)
 
 # Support `#include <tensorpipe/foo.h>`.
 target_include_directories(tensorpipe PUBLIC $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}>)
@@ -34,21 +34,27 @@
 ### basic
 
 target_sources(tensorpipe PRIVATE
-  channel/basic/channel.cc
-  channel/basic/context.cc)
+  channel/basic/channel_impl.cc
+  channel/basic/context.cc
+  channel/basic/context_impl.cc
+  channel/basic/factory.cc)
 
 ### xth
 
 target_sources(tensorpipe PRIVATE
-  channel/xth/channel.cc
-  channel/xth/context.cc)
+  channel/xth/channel_impl.cc
+  channel/xth/context.cc
+  channel/xth/context_impl.cc
+  channel/xth/factory.cc)
 
 ### cma
 
 if(TP_ENABLE_CMA)
   target_sources(tensorpipe PRIVATE
-    channel/cma/channel.cc
-    channel/cma/context.cc)
+    channel/cma/channel_impl.cc
+    channel/cma/context.cc
+    channel/cma/context_impl.cc
+    channel/cma/factory.cc)
   set(TENSORPIPE_HAS_CMA_CHANNEL 1)
 else()
   set(TENSORPIPE_HAS_CMA_CHANNEL 0)
@@ -57,8 +63,10 @@
 ### mpt
 
 target_sources(tensorpipe PRIVATE
-  channel/mpt/channel.cc
-  channel/mpt/context.cc)
+  channel/mpt/channel_impl.cc
+  channel/mpt/context.cc
+  channel/mpt/context_impl.cc
+  channel/mpt/factory.cc)
 
 ## CUDA channels
 
@@ -68,14 +76,41 @@
   target_include_directories(tensorpipe PUBLIC ${CUDA_INCLUDE_DIRS})
   set(TENSORPIPE_SUPPORTS_CUDA 1)
 
+  ### cuda_xth
+
+  target_sources(tensorpipe PRIVATE
+    channel/cuda_xth/channel_impl.cc
+    channel/cuda_xth/context.cc
+    channel/cuda_xth/context_impl.cc
+    channel/cuda_xth/factory.cc)
+
+  ### cuda_basic
+
+  target_sources(tensorpipe PRIVATE
+    channel/cuda_basic/channel_impl.cc
+    channel/cuda_basic/context.cc
+    channel/cuda_basic/context_impl.cc
+    channel/cuda_basic/factory.cc
+    common/cuda_loop.cc)
+
   ### cuda_ipc
 
   if(TP_ENABLE_CUDA_IPC)
     target_sources(tensorpipe PRIVATE
-      channel/cuda_ipc/channel.cc
-      channel/cuda_ipc/context.cc)
+      channel/cuda_ipc/channel_impl.cc
+      channel/cuda_ipc/context.cc
+      channel/cuda_ipc/context_impl.cc
+      channel/cuda_ipc/factory.cc)
     set(TENSORPIPE_HAS_CUDA_IPC_CHANNEL 1)
   endif()
+
+  target_sources(tensorpipe PRIVATE
+    common/ibv.cc
+    channel/cuda_gdr/channel_impl.cc
+    channel/cuda_gdr/context.cc
+    channel/cuda_gdr/context_impl.cc
+    channel/cuda_gdr/factory.cc)
+  set(TENSORPIPE_HAS_CUDA_GDR_CHANNEL 1)
 endif()
 
 ## Transports
@@ -83,13 +118,15 @@
 ### uv
 
 target_sources(tensorpipe PRIVATE
-  transport/uv/connection.cc
+  transport/uv/connection_impl.cc
   transport/uv/context.cc
+  transport/uv/context_impl.cc
   transport/uv/error.cc
-  transport/uv/listener.cc
+  transport/uv/factory.cc
+  transport/uv/listener_impl.cc
   transport/uv/loop.cc
   transport/uv/sockaddr.cc
-  transport/uv/uv.cc)
+  transport/uv/utility.cc)
 find_package(uv REQUIRED)
 target_link_libraries(tensorpipe PRIVATE uv::uv)
 
@@ -97,10 +134,12 @@
 
 if(TP_ENABLE_SHM)
   target_sources(tensorpipe PRIVATE
+    common/epoll_loop.cc
+    transport/shm/connection_impl.cc
     transport/shm/context.cc
-    transport/shm/connection.cc
-    transport/shm/listener.cc
-    transport/shm/loop.cc
+    transport/shm/context_impl.cc
+    transport/shm/factory.cc
+    transport/shm/listener_impl.cc
     transport/shm/reactor.cc
     transport/shm/sockaddr.cc
     util/ringbuffer/shm.cc
@@ -110,6 +149,23 @@
   set(TENSORPIPE_HAS_SHM_TRANSPORT 0)
 endif()
 
+### ibv
+
+if(TP_ENABLE_IBV)
+  target_sources(tensorpipe PRIVATE
+    common/epoll_loop.cc
+    common/ibv.cc
+    transport/ibv/connection_impl.cc
+    transport/ibv/context.cc
+    transport/ibv/context_impl.cc
+    transport/ibv/error.cc
+    transport/ibv/factory.cc
+    transport/ibv/listener_impl.cc
+    transport/ibv/reactor.cc
+    transport/ibv/sockaddr.cc
+    transport/ibv/utility.cc)
+  set(TENSORPIPE_HAS_IBV_TRANSPORT 1)
+endif()
 
 if(APPLE)
   find_library(CF CoreFoundation)

=== benchmark/CMakeLists.txt ===
# Copyright (c) Facebook, Inc. and its affiliates.
# All rights reserved.
#
# This source code is licensed under the BSD-style license found in the
# LICENSE file in the root directory of this source tree.

# TODO: Make those separate CMake projects.

add_executable(benchmark_transport benchmark_transport.cc options.cc transport_registry.cc)
target_link_libraries(benchmark_transport PRIVATE tensorpipe)

add_executable(benchmark_pipe benchmark_pipe.cc options.cc transport_registry.cc channel_registry.cc)
target_link_libraries(benchmark_pipe PRIVATE tensorpipe)

=== python/CMakeLists.txt ===
# Copyright (c) Facebook, Inc. and its affiliates.
# All rights reserved.
#
# This source code is licensed under the BSD-style license found in the
# LICENSE file in the root directory of this source tree.

if(NOT (COMMAND pybind11_add_module))
  add_subdirectory(
    ${PROJECT_SOURCE_DIR}/third_party/pybind11
    ${PROJECT_BINARY_DIR}/third_party/pybind11
    EXCLUDE_FROM_ALL)
endif()

set(PYBIND11_CPP_STANDARD -std=c++14)
pybind11_add_module(pytensorpipe tensorpipe.cc)
target_link_libraries(pytensorpipe PRIVATE tensorpipe)

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -6,6 +6,7 @@
 
 add_executable(tensorpipe_test
   test.cc
+  test_environment.cc
   transport/context_test.cc
   transport/connection_test.cc
   transport/uv/uv_test.cc
@@ -26,8 +27,8 @@
 
 if(TP_ENABLE_SHM)
   target_sources(tensorpipe_test PRIVATE
+    common/epoll_loop_test.cc
     transport/shm/reactor_test.cc
-    transport/shm/loop_test.cc
     transport/shm/connection_test.cc
     transport/shm/sockaddr_test.cc
     transport/shm/shm_test.cc
@@ -37,10 +38,21 @@
     )
 endif()
 
+if(TP_ENABLE_IBV)
+  target_sources(tensorpipe_test PRIVATE
+    common/epoll_loop_test.cc
+    transport/ibv/connection_test.cc
+    transport/ibv/ibv_test.cc
+    transport/ibv/sockaddr_test.cc
+    util/ringbuffer/ringbuffer_test.cc
+    )
+endif()
+
 if(TP_ENABLE_CMA)
   target_sources(tensorpipe_test PRIVATE
     channel/cma/cma_test.cc
     )
+  add_subdirectory(channel/cma)
 endif()
 
 if(TP_USE_CUDA)
@@ -50,15 +62,26 @@
 
   target_sources(tensorpipe_test PRIVATE
     channel/channel_test_cuda.cc
+    channel/channel_test_cuda_multi_gpu.cc
+    common/cuda_test.cc
     )
 
   cuda_add_library(tensorpipe_cuda_kernel channel/kernel.cu)
   target_link_libraries(tensorpipe_test PRIVATE tensorpipe_cuda_kernel)
-endif()
 
-if(TP_ENABLE_CUDA_IPC)
   target_sources(tensorpipe_test PRIVATE
-    channel/cuda_ipc/cuda_ipc_test.cc
+    channel/cuda_xth/cuda_xth_test.cc
+    channel/cuda_basic/cuda_basic_test.cc
+    )
+
+  if(TP_ENABLE_CUDA_IPC)
+    target_sources(tensorpipe_test PRIVATE
+      channel/cuda_ipc/cuda_ipc_test.cc
+      )
+  endif()
+
+  target_sources(tensorpipe_test PRIVATE
+    channel/cuda_gdr/cuda_gdr_test.cc
     )
 endif()
 
@@ -69,4 +92,5 @@
 target_link_libraries(tensorpipe_test PRIVATE
   tensorpipe
   uv::uv
+  gmock
   gtest_main)

=== test/channel/cma/CMakeLists.txt ===
# Copyright (c) Facebook, Inc. and its affiliates.
# All rights reserved.
#
# This source code is licensed under the BSD-style license found in the
# LICENSE file in the root directory of this source tree.

add_executable(tensorpipe_channel_cma_probe
  probe.cc
)

target_link_libraries(tensorpipe_channel_cma_probe PRIVATE
  tensorpipe
)

=== debian/changelog ===
tensorpipe (0.0~git20210304.369e855-2.1) unstable; urgency=high

  * Non-maintainer upload.
  * debian/not-installed: Also exclude the following files from
    installation: (Closes: #997774)
    + usr/lib/*/cmake/GTest/GMockTargets-none.cmake
    + usr/lib/*/cmake/GTest/GMockTargets.cmake

 -- Boyuan Yang <byang@debian.org>  Tue, 07 Dec 2021 15:09:03 -0500

tensorpipe (0.0~git20210304.369e855-2) unstable; urgency=medium

  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Thu, 02 Sep 2021 02:19:19 +0000

tensorpipe (0.0~git20210304.369e855-1) experimental; urgency=medium

  * New upstream version 0.0~git20210304.369e855
    Please pin to this snapshot for PyTorch/v1.8.1
  * Refresh the list of header files to install.

 -- Mo Zhou <lumin@debian.org>  Wed, 19 May 2021 16:20:52 +0800

=== debian/control ===
--- 
+++ 
@@ -14,12 +14,13 @@
                libuv1-dev,
                pkg-config,
                protobuf-compiler,
+               libnop-dev,
 Rules-Requires-Root: no
 
 Package: libtensorpipe-dev
 Section: libdevel
 Architecture: any
-Depends: libtensorpipe0 (= ${binary:Version}), ${misc:Depends}
+Depends: libtensorpipe0 (= ${binary:Version}), ${misc:Depends}, libnop-dev
 Description: tensor-aware point-to-point communication primitive for machine learning
  The TensorPipe project provides a tensor-aware channel to transfer rich
  objects from one process to another while using the fastest transport for the

## tensorpipe 0.0~git20220513.bb1473a

=== CMakeLists.txt ===
# Copyright (c) Meta Platforms, Inc. and affiliates.
# All rights reserved.
#
# This source code is licensed under the BSD-style license found in the
# LICENSE file in the root directory of this source tree.

cmake_minimum_required(VERSION 3.5 FATAL_ERROR)

project(tensorpipe LANGUAGES C CXX)

set(CMAKE_CXX_STANDARD 14)

list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")

# Expose build options.
include(Options)

# Define sanitizer option, if specified.
include(Sanitize)

# Misc checks to cope with various compiler modes.
include(MiscCheck)

add_subdirectory(tensorpipe)

install(EXPORT TensorpipeTargets
        DESTINATION share/cmake/Tensorpipe
        FILE TensorpipeTargets.cmake)

=== tensorpipe/python/CMakeLists.txt ===
# Copyright (c) Meta Platforms, Inc. and affiliates.
# All rights reserved.
#
# This source code is licensed under the BSD-style license found in the
# LICENSE file in the root directory of this source tree.

if(NOT (COMMAND pybind11_add_module))
  add_subdirectory(
    ${PROJECT_SOURCE_DIR}/third_party/pybind11
    ${PROJECT_BINARY_DIR}/third_party/pybind11
    EXCLUDE_FROM_ALL)
endif()

set(PYBIND11_CPP_STANDARD -std=c++14)
pybind11_add_module(pytensorpipe tensorpipe.cc)
target_link_libraries(pytensorpipe PRIVATE tensorpipe)

=== debian/changelog ===
tensorpipe (0.0~git20220513.bb1473a-5build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:03:39 +1100

tensorpipe (0.0~git20220513.bb1473a-5build1) noble; urgency=medium

  * No-change rebuild for libuv t64.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 14 Mar 2024 16:54:04 +0100

tensorpipe (0.0~git20220513.bb1473a-5) unstable; urgency=medium

  * Upload to unstable.
  + Please pin to this snapshot for PyTorch/v2.0.X releases.

 -- Mo Zhou <lumin@debian.org>  Sat, 19 Aug 2023 23:22:31 -0400

tensorpipe (0.0~git20220513.bb1473a-4) experimental; urgency=medium

  [ Debian Janitor ]
  * Set field Upstream-Name in debian/copyright.
  * Set upstream metadata fields: Bug-Database, Bug-Submit.
  * Update standards version to 4.6.0, no changes needed.
  * Apply multi-arch hints. + libtensorpipe0: Add Multi-Arch: same.

  [ Mo Zhou ]
  * Add control files for the CUDA version of tensorpipe.
  * Add script cudabuild.sh to convert debian/ for cuda version.
  * Let the CPU/CUDA version Conflicts+Replaces each other.
  * Add SOVERSION for the CUDA version as well.
  * Only install the public headers (no longer install private headers).
  * cme update dpkg-copyright.

 -- Mo Zhou <lumin@debian.org>  Sat, 19 Aug 2023 23:22:07 -0400

tensorpipe (0.0~git20220513.bb1473a-3) unstable; urgency=medium

  * Add patch to fix GCC-12 FTBFS. (Closes: #1013051)

 -- Mo Zhou <lumin@debian.org>  Tue, 26 Jul 2022 08:58:23 -0700

tensorpipe (0.0~git20220513.bb1473a-2) unstable; urgency=medium

  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Sun, 26 Jun 2022 10:01:02 -0700

tensorpipe (0.0~git20220513.bb1473a-1) experimental; urgency=medium

  * New upstream version 0.0~git20220513.bb1473a
    This snapshot should be fine with PyTorch/v1.12.X
  * Refresh existing patches.
  * Update installation control file.
  * Upload to experimental.

 -- Mo Zhou <lumin@debian.org>  Thu, 23 Jun 2022 22:35:00 -0700

=== debian/control ===
--- 
+++ 
@@ -2,10 +2,11 @@
 Section: science
 Homepage: https://github.com/pytorch/tensorpipe
 Priority: optional
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Vcs-Git: https://salsa.debian.org/deeplearning-team/tensorpipe.git
 Vcs-Browser: https://salsa.debian.org/deeplearning-team/tensorpipe
-Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
 Uploaders: Mo Zhou <lumin@debian.org>
 Build-Depends: cmake,
                debhelper-compat (= 13),
@@ -21,6 +22,8 @@
 Section: libdevel
 Architecture: any
 Depends: libtensorpipe0 (= ${binary:Version}), ${misc:Depends}, libnop-dev
+Conflicts: libtensorpipe-cuda-dev
+Replaces: libtensorpipe-cuda-dev
 Description: tensor-aware point-to-point communication primitive for machine learning
  The TensorPipe project provides a tensor-aware channel to transfer rich
  objects from one process to another while using the fastest transport for the
@@ -32,6 +35,9 @@
 Section: libs
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}
+Multi-Arch: same
+Conflicts: libtensorpipe-cuda-0
+Replaces: libtensorpipe-cuda-0
 Description: tensor-aware point-to-point communication primitive for machine learning
  The TensorPipe project provides a tensor-aware channel to transfer rich
  objects from one process to another while using the fastest transport for the

## tensorpipe 0.0~git20250815.af0118d

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,11 +4,11 @@
 # This source code is licensed under the BSD-style license found in the
 # LICENSE file in the root directory of this source tree.
 
-cmake_minimum_required(VERSION 3.5 FATAL_ERROR)
+cmake_minimum_required(VERSION 3.18 FATAL_ERROR)
 
 project(tensorpipe LANGUAGES C CXX)
 
-set(CMAKE_CXX_STANDARD 14)
+set(CMAKE_CXX_STANDARD 17)
 
 list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")

=== tensorpipe/CMakeLists.txt ===
# Copyright (c) Meta Platforms, Inc. and affiliates.
# All rights reserved.
#
# This source code is licensed under the BSD-style license found in the
# LICENSE file in the root directory of this source tree.

# TP_SRCS is the list of source files that we need to build libtensorpipe.
set(TP_SRCS)

# TP_PUBLIC_HDRS is the list of public header files that we need to install.
set(TP_PUBLIC_HDRS)

# TP_LINK_LIBRARIES is list of dependent libraries to be linked
set(TP_LINK_LIBRARIES)

# TP_INCLUDE_DIRS is list of include path to be used
set(TP_INCLUDE_DIRS)

list(APPEND TP_SRCS
  channel/error.cc
  channel/helpers.cc
  common/address.cc
  common/allocator.cc
  common/error.cc
  common/fd.cc
  common/socket.cc
  common/system.cc
  core/context.cc
  core/context_impl.cc
  core/error.cc
  core/listener.cc
  core/listener_impl.cc
  core/pipe.cc
  core/pipe_impl.cc
  transport/error.cc)

list(APPEND TP_PUBLIC_HDRS
  tensorpipe.h
  channel/context.h
  channel/error.h
  common/buffer.h
  common/cpu_buffer.h
  common/device.h
  common/error.h
  common/optional.h
  core/context.h
  core/error.h
  core/listener.h
  core/message.h
  core/pipe.h
  transport/context.h
  transport/error.h)

list(APPEND TP_INCLUDE_DIRS
  $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}>
  $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}>
  $<INSTALL_INTERFACE:${TP_INSTALL_INCLUDEDIR}>)


## Channels

### basic

list(APPEND TP_SRCS
  channel/basic/channel_impl.cc
  channel/basic/context_impl.cc
  channel/basic/factory.cc)
list(APPEND TP_PUBLIC_HDRS
  channel/basic/factory.h)

### xth

list(APPEND TP_SRCS
  channel/xth/channel_impl.cc
  channel/xth/context_impl.cc
  channel/xth/factory.cc)
list(APPEND TP_PUBLIC_HDRS
  channel/xth/factory.h)

### cma

tp_conditional_backend(
  TP_ENABLE_CMA "Enable cross-memory attach channel" "LINUX")
if(TP_ENABLE_CMA)
  list(APPEND TP_SRCS
    channel/cma/channel_impl.cc
    channel/cma/context_impl.cc
    channel/cma/factory.cc)
  list(APPEND TP_PUBLIC_HDRS
    channel/cma/factory.h)
  set(TENSORPIPE_HAS_CMA_CHANNEL 1)
endif()

### mpt

list(APPEND TP_SRCS
  channel/mpt/channel_impl.cc
  channel/mpt/context_impl.cc
  channel/mpt/factory.cc)
list(APPEND TP_PUBLIC_HDRS
  channel/mpt/factory.h)

## Transports

### uv

list(APPEND TP_SRCS
  transport/uv/connection_impl.cc
  transport/uv/context_impl.cc
  transport/uv/error.cc
  transport/uv/factory.cc
  transport/uv/listener_impl.cc
  transport/uv/loop.cc
  transport/uv/sockaddr.cc
  transport/uv/utility.cc)
list(APPEND TP_PUBLIC_HDRS
  transport/uv/error.h
  transport/uv/factory.h
  transport/uv/utility.h)

# Add uv package
find_package(uv REQUIRED)
list(APPEND TP_LINK_LIBRARIES uv::uv)

### shm

tp_conditional_backend(
  TP_ENABLE_SHM "Enable shared-memory transport" "LINUX")
if(TP_ENABLE_SHM)
  list(APPEND TP_SRCS
    common/epoll_loop.cc
    common/shm_segment.cc
    transport/shm/connection_impl.cc
    transport/shm/context_impl.cc
    transport/shm/factory.cc
    transport/shm/listener_impl.cc
    transport/shm/reactor.cc
    transport/shm/sockaddr.cc)
  list(APPEND TP_PUBLIC_HDRS
    transport/shm/factory.h)
  set(TENSORPIPE_HAS_SHM_TRANSPORT 1)
endif()

### ibv

tp_conditional_backend(
  TP_ENABLE_IBV "Enable InfiniBand transport" "LINUX")
if(TP_ENABLE_IBV)
  list(APPEND TP_SRCS
    common/epoll_loop.cc
    common/ibv.cc
    transport/ibv/connection_impl.cc
    transport/ibv/context_impl.cc
    transport/ibv/error.cc
    transport/ibv/factory.cc
    transport/ibv/listener_impl.cc
    transport/ibv/reactor.cc
    transport/ibv/sockaddr.cc
    transport/ibv/utility.cc)
  list(APPEND TP_PUBLIC_HDRS
    transport/ibv/error.h
    transport/ibv/factory.h
    transport/ibv/utility.h)
  set(TENSORPIPE_HAS_IBV_TRANSPORT 1)
endif()


## MAC OS specific library deps

if(APPLE)
  find_library(CF CoreFoundation)
  find_library(IOKIT IOKit)
  list(APPEND TP_LINK_LIBRARIES ${CF} ${IOKIT})
endif()


## Config

configure_file(config.h.in config.h)


## Libnop

# We should keep libnop headers private as they should not be exposed to downstream users,
# but they're currently transitively included by tensorpipe/transport/connection.h (which
# is still unclear whether it should be a public or private header).
list(APPEND TP_INCLUDE_DIRS $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/third_party/libnop/include>)


## Target

# Add the tensorpipe library target
add_library(tensorpipe ${TP_STATIC_OR_SHARED} ${TP_SRCS})

# Set target properties
if(BUILD_SHARED_LIBS)
  set_target_properties(tensorpipe PROPERTIES POSITION_INDEPENDENT_CODE 1)
endif()

# Add all the link libraries and include directories to the tensorpipe target and keeping the link PUBLIC
target_link_libraries(tensorpipe PRIVATE ${TP_LINK_LIBRARIES})
target_include_directories(tensorpipe PUBLIC ${TP_INCLUDE_DIRS})


## Install

install(TARGETS tensorpipe
        EXPORT TensorpipeTargets
        LIBRARY DESTINATION ${TP_INSTALL_LIBDIR}
        ARCHIVE DESTINATION ${TP_INSTALL_LIBDIR})

foreach(_header_file ${TP_PUBLIC_HDRS})
  get_filename_component(_TP_HEADER_SUBDIR "${_header_file}" DIRECTORY)
  install(FILES ${_header_file}
          DESTINATION ${TP_INSTALL_INCLUDEDIR}/tensorpipe/${_TP_HEADER_SUBDIR})
endforeach()

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/config.h
        DESTINATION ${TP_INSTALL_INCLUDEDIR}/tensorpipe)


## CUDA

if(TP_USE_CUDA)
  # TP_SRCS is the list of source files that we need to build libtensorpipe.
  set(TP_CUDA_SRCS)

  # TP_PUBLIC_HDRS is the list of public header files that we need to install.
  set(TP_CUDA_PUBLIC_HDRS)

  # TP_LINK_LIBRARIES is list of dependent libraries to be linked
  set(TP_CUDA_LINK_LIBRARIES)

  # TP_INCLUDE_DIRS is list of include path to be used
  set(TP_CUDA_INCLUDE_DIRS)

  find_package(CUDA REQUIRED)
  list(APPEND TP_CUDA_LINK_LIBRARIES ${CUDA_LIBRARIES})
  list(APPEND TP_CUDA_INCLUDE_DIRS ${CUDA_INCLUDE_DIRS})

  list(APPEND TP_CUDA_SRCS
    common/cuda_buffer.cc)
  list(APPEND TP_CUDA_PUBLIC_HDRS
    tensorpipe_cuda.h
    common/cuda_buffer.h)

  ### cuda_xth

  list(APPEND TP_CUDA_SRCS
    channel/cuda_xth/channel_impl.cc
    channel/cuda_xth/context_impl.cc
    channel/cuda_xth/factory.cc)
  list(APPEND TP_CUDA_PUBLIC_HDRS
    channel/cuda_xth/factory.h)

  ### cuda_basic

  list(APPEND TP_CUDA_SRCS
    channel/cuda_basic/channel_impl.cc
    channel/cuda_basic/context_impl.cc
    channel/cuda_basic/factory.cc
    common/cuda_loop.cc)
  list(APPEND TP_CUDA_PUBLIC_HDRS
    channel/cuda_basic/factory.h)

  ### cuda_ipc

  tp_conditional_backend(
    TP_ENABLE_CUDA_IPC "Enable CUDA inter-process communication channel" "TP_USE_CUDA")
  if(TP_ENABLE_CUDA_IPC)
    list(APPEND TP_CUDA_SRCS
      channel/cuda_ipc/channel_impl.cc
      channel/cuda_ipc/context_impl.cc
      channel/cuda_ipc/factory.cc)
    list(APPEND TP_CUDA_PUBLIC_HDRS
      channel/cuda_ipc/factory.h)
    set(TENSORPIPE_HAS_CUDA_IPC_CHANNEL 1)
  endif()

  ### cuda_gdr

  tp_conditional_backend(
    TP_ENABLE_CUDA_GDR "Enable CUDA GpuDirect (InfiniBand) channel" "LINUX")
  if(TP_ENABLE_CUDA_GDR)
    list(APPEND TP_CUDA_SRCS
      common/ibv.cc
      channel/cuda_gdr/channel_impl.cc
      channel/cuda_gdr/context_impl.cc
      channel/cuda_gdr/factory.cc)
    list(APPEND TP_CUDA_PUBLIC_HDRS
      channel/cuda_gdr/error.h
      channel/cuda_gdr/factory.h)
    set(TENSORPIPE_HAS_CUDA_GDR_CHANNEL 1)
  endif()

  configure_file(config_cuda.h.in config_cuda.h)

  add_library(tensorpipe_cuda ${TP_STATIC_OR_SHARED} ${TP_CUDA_SRCS})

  if(BUILD_SHARED_LIBS)
    set_target_properties(tensorpipe_cuda PROPERTIES POSITION_INDEPENDENT_CODE 1)
  endif()

  target_link_libraries(tensorpipe_cuda PUBLIC tensorpipe)
  target_link_libraries(tensorpipe_cuda PRIVATE ${TP_CUDA_LINK_LIBRARIES})
  target_include_directories(tensorpipe_cuda PUBLIC ${TP_CUDA_INCLUDE_DIRS})

  install(TARGETS tensorpipe_cuda
          EXPORT TensorpipeTargets
          LIBRARY DESTINATION ${TP_INSTALL_LIBDIR}
          ARCHIVE DESTINATION ${TP_INSTALL_LIBDIR})

  foreach(_header_file ${TP_CUDA_PUBLIC_HDRS})
    get_filename_component(_TP_HEADER_SUBDIR "${_header_file}" DIRECTORY)
    install(FILES ${_header_file}
            DESTINATION ${TP_INSTALL_INCLUDEDIR}/tensorpipe/${_TP_HEADER_SUBDIR})
  endforeach()

  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/config_cuda.h
          DESTINATION ${TP_INSTALL_INCLUDEDIR}/tensorpipe)

endif()


## Python bindings

if(TP_BUILD_PYTHON)
  add_subdirectory(python)
endif()


## Benchmarks

if (TP_BUILD_BENCHMARK)
  add_subdirectory(benchmark)
endif()


## Misc tools

if (TP_BUILD_MISC)
  add_subdirectory(misc)
endif()


## Tests

if(TP_BUILD_TESTING)
  add_subdirectory(test)
endif()

=== tensorpipe/benchmark/CMakeLists.txt ===
# Copyright (c) Meta Platforms, Inc. and affiliates.
# All rights reserved.
#
# This source code is licensed under the BSD-style license found in the
# LICENSE file in the root directory of this source tree.

# TODO: Make those separate CMake projects.

add_executable(benchmark_transport benchmark_transport.cc options.cc transport_registry.cc)
target_link_libraries(benchmark_transport PRIVATE tensorpipe)

add_executable(benchmark_pipe benchmark_pipe.cc options.cc transport_registry.cc channel_registry.cc)
target_link_libraries(benchmark_pipe PRIVATE tensorpipe tensorpipe_cuda)

=== tensorpipe/python/CMakeLists.txt ===
--- 
+++ 
@@ -11,6 +11,6 @@
     EXCLUDE_FROM_ALL)
 endif()
 
-set(PYBIND11_CPP_STANDARD -std=c++14)
+set(PYBIND11_CPP_STANDARD -std=c++17)
 pybind11_add_module(pytensorpipe tensorpipe.cc)
 target_link_libraries(pytensorpipe PRIVATE tensorpipe)

=== tensorpipe/test/CMakeLists.txt ===
# Copyright (c) Meta Platforms, Inc. and affiliates.
# All rights reserved.
#
# This source code is licensed under the BSD-style license found in the
# LICENSE file in the root directory of this source tree.

# List of source files that we need to build tensorpipe_test executable.
set(TP_TEST_SRCS)

# TP_TEST_LINK_LIBRARIES is list of dependent libraries to be linked
set(TP_TEST_LINK_LIBRARIES)

# TP_TEST_INCLUDE_DIRS is list of include path to be used
set(TP_TEST_INCLUDE_DIRS)

# TP_TEST_COMPILE_DEFS is list of compile definitions to be used
set(TP_TEST_COMPILE_DEFS)

list(APPEND TP_TEST_SRCS
  test.cc
  test_environment.cc
  transport/context_test.cc
  transport/connection_test.cc
  transport/uv/uv_test.cc
  transport/uv/context_test.cc
  transport/uv/loop_test.cc
  transport/uv/connection_test.cc
  transport/uv/sockaddr_test.cc
  transport/listener_test.cc
  core/context_test.cc
  core/pipe_test.cc
  channel/basic/basic_test.cc
  channel/xth/xth_test.cc
  channel/mpt/mpt_test.cc
  channel/channel_test.cc
  channel/channel_test_cpu.cc
  common/system_test.cc
  common/defs_test.cc
  )

if(TP_ENABLE_SHM)
  list(APPEND TP_TEST_SRCS
    common/epoll_loop_test.cc
    common/ringbuffer_test.cc
    common/shm_ringbuffer_test.cc
    common/shm_segment_test.cc
    transport/shm/reactor_test.cc
    transport/shm/connection_test.cc
    transport/shm/listener_test.cc
    transport/shm/sockaddr_test.cc
    transport/shm/shm_test.cc
    )
endif()

if(TP_ENABLE_IBV)
  list(APPEND TP_TEST_SRCS
    common/epoll_loop_test.cc
    common/ringbuffer_test.cc
    transport/ibv/connection_test.cc
    transport/ibv/ibv_test.cc
    transport/ibv/sockaddr_test.cc
    )
endif()

if(TP_ENABLE_CMA)
  list(APPEND TP_TEST_SRCS
    channel/cma/cma_test.cc
    )
  add_subdirectory(channel/cma)
endif()

if(TP_USE_CUDA)
  find_package(CUDA REQUIRED)
  list(APPEND TP_TEST_LINK_LIBRARIES ${CUDA_LIBRARIES})
  list(APPEND TP_TEST_INCLUDE_DIRS ${CUDA_INCLUDE_DIRS})
  list(APPEND TP_TEST_COMPILE_DEFS TP_USE_CUDA)

  list(APPEND TP_TEST_SRCS
    channel/channel_test_cuda.cc
    channel/channel_test_cuda_multi_gpu.cc
    channel/channel_test_cuda_xdtt.cc
    common/cuda_test.cc
    core/pipe_cuda_test.cc
    )

  list(APPEND TP_TEST_SRCS
    channel/cuda_xth/cuda_xth_test.cc
    channel/cuda_basic/cuda_basic_test.cc
    )

  if(TP_ENABLE_CUDA_IPC)
    list(APPEND TP_TEST_SRCS
      channel/cuda_ipc/cuda_ipc_test.cc
      )
  endif()

  list(APPEND TP_TEST_SRCS
    channel/cuda_gdr/cuda_gdr_test.cc
    )

  cuda_add_library(tensorpipe_cuda_kernel channel/kernel.cu)
  list(APPEND TP_TEST_LINK_LIBRARIES tensorpipe_cuda_kernel)

  list(APPEND TP_TEST_LINK_LIBRARIES tensorpipe_cuda)
endif()

add_subdirectory(${PROJECT_SOURCE_DIR}/third_party/googletest
  ${PROJECT_BINARY_DIR}/third_party/googletest EXCLUDE_FROM_ALL)

list(APPEND TP_TEST_LINK_LIBRARIES
  tensorpipe
  uv::uv
  gmock
  gtest_main)

add_executable(tensorpipe_test ${TP_TEST_SRCS})

# Add all the dependent link libraries to the tensorpipe_test target
target_link_libraries(tensorpipe_test PRIVATE ${TP_TEST_LINK_LIBRARIES})
target_include_directories(tensorpipe_test PUBLIC ${TP_TEST_INCLUDE_DIRS})
target_compile_definitions(tensorpipe_test PRIVATE ${TP_TEST_COMPILE_DEFS})

=== tensorpipe/test/channel/cma/CMakeLists.txt ===
# Copyright (c) Meta Platforms, Inc. and affiliates.
# All rights reserved.
#
# This source code is licensed under the BSD-style license found in the
# LICENSE file in the root directory of this source tree.

add_executable(tensorpipe_channel_cma_probe
  probe.cc
)

target_link_libraries(tensorpipe_channel_cma_probe PRIVATE
  tensorpipe
)

=== debian/changelog ===
tensorpipe (0.0~git20250815.af0118d-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 0.0~git20250815.af0118d.
  * d/patches: fix FTBFS with GCC-15 (closes: #1097984).
  * d/control:
    + bump std-ver to 4.7.2 (no changes required).
    + replace obsolete B-D pkg-config -> pkgconf.
    + update description of binary packages.
  * d/upstream: add Repository field in metadata.
  * d/{control,rules}: build with ninja, skip running tests when building.

 -- Shengqi Chen <harry@debian.org>  Sat, 13 Sep 2025 17:59:49 +0800

tensorpipe (0.0~git20220513.bb1473a-6) unstable; urgency=medium

  * [CUDA] Manual rebuild.

 -- Mo Zhou <lumin@debian.org>  Thu, 05 Dec 2024 12:14:24 -0500

=== debian/control ===
Source: tensorpipe
Section: science
Homepage: https://github.com/pytorch/tensorpipe
Priority: optional
Standards-Version: 4.7.2
Vcs-Git: https://salsa.debian.org/deeplearning-team/tensorpipe.git
Vcs-Browser: https://salsa.debian.org/deeplearning-team/tensorpipe
Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
Uploaders: Mo Zhou <lumin@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               libgtest-dev,
               libprotobuf-dev,
               libuv1-dev,
               pkgconf,
               protobuf-compiler,
               libnop-dev,
               ninja-build,
Rules-Requires-Root: no

Package: libtensorpipe-dev
Section: libdevel
Architecture: any
Depends: libtensorpipe0 (= ${binary:Version}), ${misc:Depends}, libnop-dev
Conflicts: libtensorpipe-cuda-dev
Replaces: libtensorpipe-cuda-dev
Description: tensor-aware P2P comm primitive for machine learning (development files)
 The TensorPipe project provides a tensor-aware channel to transfer rich
 objects from one process to another while using the fastest transport for the
 tensors contained therein (e.g., CUDA device-to-device copy).
 .
 This package contains development files.

Package: libtensorpipe0
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Conflicts: libtensorpipe-cuda-0
Replaces: libtensorpipe-cuda-0
Description: tensor-aware P2P comm primitive for machine learning (shared library)
 The TensorPipe project provides a tensor-aware channel to transfer rich
 objects from one process to another while using the fastest transport for the
 tensors contained therein (e.g., CUDA device-to-device copy).
 .
 This package contains shared objects.

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export CUDA_HOME=/usr
ifneq (,$(shell command -v nvcc)) # XXX: CUDA
export CC=cuda-gcc
export CXX=cuda-g++
endif

ifneq (,$(filter $(DEB_HOST_ARCH), armel m68k mipsel powerpc riscv64 sh4))
  export DEB_LDFLAGS_MAINT_APPEND += -Wl,--no-as-needed -latomic -Wl,--as-needed
endif

%:
	dh $@ -Scmake+ninja

override_dh_auto_configure:
	-$(RM) -rfv third_party/googletest third_party/libuv
	ln -sfv /usr/src/googletest third_party/
ifneq (,$(shell command -v nvcc))
	dh_auto_configure -- -DBUILD_SHARED_LIBS=ON -DTP_BUILD_TESTING=ON -DTP_USE_CUDA=ON
else
	dh_auto_configure -- -DBUILD_SHARED_LIBS=ON -DTP_BUILD_TESTING=ON
endif

# tests are compiled only
override_dh_auto_test:

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none" \
https://github.com/pytorch/tensorpipe \
HEAD debian uupdate
